﻿Public Class Person
    Public Property Name() As String
        Get
            Return m_Name
        End Get
        Set(value As String)
            m_Name = value
        End Set
    End Property
    Private m_Name As String
    Public Property Age() As Integer
        Get
            Return m_Age
        End Get
        Set(value As Integer)
            m_Age = value
        End Set
    End Property
    Private m_Age As Integer
    Public Property Address() As String
        Get
            Return m_Address
        End Get
        Set(value As String)
            m_Address = value
        End Set
    End Property
    Private m_Address As String
    Public Property Residence() As String
        Get
            Return m_Residence
        End Get
        Set(value As String)
            m_Residence = value
        End Set
    End Property
    Private m_Residence As String
    Public Property Born() As String
        Get
            Return m_Born
        End Get
        Set(value As String)
            m_Born = value
        End Set
    End Property
    Private m_Born As String
    '[Display(AutoGenerateField=false)]
    Public Property BirthDate() As DateTime
        Get
            Return m_BirthDate
        End Get
        Set(value As DateTime)
            m_BirthDate = value
        End Set
    End Property
    Private m_BirthDate As DateTime

    Private Shared Randomizer As New Random()

    Public Shared Function Generate(qty As Integer) As List(Of Person)
        Dim items = New List(Of Person)()
        For i As Integer = 0 To qty - 1
            items.Add(New Person() With { _
              .Name = Names(Randomizer.[Next](Names.Length)) & " " & Surnames(Randomizer.[Next](Surnames.Length)), _
              .Address = Streets(Randomizer.[Next](Streets.Length)) & " " & (1000 + Randomizer.[Next](8999)).ToString(), _
              .Age = 10 + Randomizer.[Next](40), _
              .Residence = Countries(Randomizer.[Next](Countries.Length)), _
              .Born = Countries(Randomizer.[Next](Countries.Length)), _
              .BirthDate = GetBirthDate(Randomizer) _
            })
        Next
        Return items
    End Function

    Private Shared Function GetBirthDate(r As Random) As DateTime
        Dim lowerDateTicks As Long = New DateTime(1920, 1, 1).Ticks
        Dim upperDateTicks As Long = DateTime.Now.Ticks
        Dim newDateTicks As Long = lowerDateTicks + Convert.ToInt64(Convert.ToDouble(upperDateTicks - lowerDateTicks) * r.NextDouble())
        Return New DateTime(newDateTicks)
    End Function
    Private Shared Streets As String() = New String() {"5th Avenue", "10th Avenue", "13th Street", "Solano García", "Fray Bentos", "Lois Albert Herrera", _
     "Brasil Avenue", "Kenedy Avenue", "Peter Campbell", "Missisipi"}

    Private Shared Names As String() = New String() {"Michael", "John", "Bernardo", "Alvaro", "Max", "Leonard", _
     "Noela", "Gabriel", "Bruno", "Rodrigo", "Sheela", "Chris", _
     "Martin", "Ben", "Alex", "Irina", "Dave", "Patric"}

    Private Shared Surnames As String() = New String() {"Johnson", "Alvarez", "Maxtor", "Johansen", "Vera", "García", _
     "Days", "Castle", "Varela", "Smith", "Gates", "Meredith", _
     "Drexler", "Beckham", "Jobs"}

    Private Shared Countries As String() = New String() {"Afghanistan", "Albania", "Algeria", "Andorra", "Angola", "Antigua and Barbuda", _
     "Argentina", "Armenia", "Australia", "Austria", "Azerbaijan", "Bahrain", _
     "Bangladesh", "Barbados", "Belarus", "Belgium", "Belize", "Benin", _
     "Bhutan", "Bolivia", "Bosnia and Herzegovina", "Botswana", "Brazil", "Brunei", _
     "Bulgaria", "Burkina Faso", "Burundi", "Côte d'Ivoire", "Cambodia", "Cameroon", _
     "Canada", "Cape Verde", "Central African Republic", "Chad", "Chile", "China", _
     "Colombia", "Comoros", "Congo", "Costa Rica", "Croatia", "Cuba", _
     "Cyprus", "Czech Republic", "Democratic Republic of the Congo", "Denmark", "Djibouti", "Dominica", _
     "Dominican Republic", "Ecuador", "Egypt", "El Salvador", "Equatorial Guinea", "Eritrea", _
     "Estonia", "Ethiopia", "Fiji", "Finland", "Former Yugoslav Republic of Macedonia", "France", _
     "Gabon", "Georgia", "Germany", "Ghana", "Greece", "Grenada", _
     "Guatemala", "Guinea", "Guinea-Bissau", "Guyana", "Haiti", "Honduras", _
     "Hungary", "Iceland", "India", "Indonesia", "Iran", "Iraq", _
     "Ireland", "Israel", "Italy", "Jamaica", "Japan", "Jordan", _
     "Kazakhstan", "Kenya", "Kiribati", "Kuwait", "Kyrgyzstan", "Laos", _
     "Latvia", "Lebanon", "Lesotho", "Liberia", "Libya", "Liechtenstein", _
     "Lithuania", "Luxembourg ", "Macau -- ", "Madagascar", "Malawi", "Malaysia", _
     "Maldives", "Mali", "Malta", "Marshall Islands", "Mauritania", "Mauritius", _
     "Mexico", "Micronesia", "Moldova", "Monaco", "Mongolia", "Morocco", _
     "Mozambique", "Myanmar", "Namibia", "Nauru", "Nepal", "Netherlands", _
     "New Zealand", "Nicaragua", "Niger", "Nigeria", "North Korea", "Norway", _
     "Oman", "Pakistan", "Palau", "Panama", "Papua New Guinea", "Paraguay", _
     "Peru", "Philippines", "Poland", "Portugal", "Qatar", "Romania", _
     "Russia", "Rwanda", "São Tomé and Príncipe", "Saint Kitts and Nevis", "Saint Lucia", "Saint Vincent and the Grenadines", _
     "Samoa", "San Marino", "Saudi Arabia", "Senegal", "Seychelles", "Sierra Leone", _
     "Singapore", "Slovakia", "Slovenia", "Solomon Islands", "Somalia", "South Africa", _
     "South Korea", "Spain", "Sri Lanka", "Sudan", "Suriname", "Swaziland", _
     "Sweden", "Switzerland", "Syria", "Taiwan", "Tajikistan", "Tanzania", _
     "Thailand", "The Bahamas", "The Gambia", "Togo", "Tonga", "Trinidad and Tobago", _
     "Tunisia", "Turkey", "Turkmenistan", "Tuvalu", "Uganda", "Ukraine", _
     "United Arab Emirates", "United Kingdom", "United States", "Uruguay", "Uzbekistan", "Vanuatu", _
     "Vatican City", "Venezuela", "Vietnam", "Western Sahara", "Yemen", "Yugoslavia", _
     "Zambia", "Zimbabwe"}
End Class

